change fileserver host
[distro-setup] / distro-end
index cd3de8162f962c058b7c3b5f7c06c4777df25251..392bcef5d9e1ffeea304ea2836ec684e1afad68b 100755 (executable)
@@ -1,8 +1,19 @@
 #!/bin/bash -l
 # Copyright (C) 2016 Ian Kelling
-# This program is under GPL v. 3 or later, see <http://www.gnu.org/licenses/>
-set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
+
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+
+#     http://www.apache.org/licenses/LICENSE-2.0
+
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+errcatch
 
 set -x
 
@@ -32,50 +43,65 @@ esac
 pup
 
 simple_packages=(
+    htop
     mailutils
     nmon
+    rdiff-backup
     ruby
     ruby-rest-client
     tree
     vim
 )
 
-if [[ $HOSTNAME != lj && $HOSTNAME != lk ]]; then
-    # universal packages
-    simple_packages+=(
-        apache2
-        bwm-ng
-        chromium
-        duplicity
-        evince
-        fdupes
-        filelight
-        gdb
-        gnome-screenshot
-        jq
-        locate
-        meld
-        offlineimap
-        p7zip
-        paprefs
-        pavucontrol
-        pdfgrep
-        pianobar
-        pidgin
-        rdiff-backup
-        slock
-        squashfs-tools
-        tcpdump
-        transmission-remote-gtk
-        vlc
-    )
-fi
+case $HOSTNAME in
+    lj|li) : ;;
+    *)
+        # universal packages
+        # swh-plugins is for karaoke pulsaudio filter.
+        simple_packages+=(
+            apache2
+            bwm-ng
+            chromium
+            duplicity
+            evince
+            fdupes
+            filelight
+            gdb
+            goaccess
+            gnome-screenshot
+            jq
+            locate
+            meld
+            nmap
+            offlineimap
+            p7zip
+            paprefs
+            pavucontrol
+            pdfgrep
+            pianobar
+            pidgin
+            slock
+            squashfs-tools
+            swh-plugins
+            tcpdump
+            transmission-remote-gtk
+            vlc
+        )
+        ;;
+esac
 
 
 
-########### begin section including lj ################
+########### begin section including li ################
 
 
+case $distro in
+    debian)
+        if [[ `debian-archive` == testing ]]; then
+            pi acme-tiny
+        fi
+esac
+
 case $distro in
     fedora) spa unrar ;;
     *) spa unrar-free ;;
@@ -172,7 +198,10 @@ case $(distro-name) in
         # this says disabling the service, it will still get restarted
         # but this script doesn't do anything on restart, so it should be fine
         s dd of=/var/run/motd.dynamic if=/dev/null
-        s update-rc.d motd disable
+        # stretch doesn't have initscripts pkg installed by default
+        if [[ $(debian-codename) == jessie ]]; then
+            s update-rc.d motd disable
+        fi
         ;;
     ubuntu)
         # this isn't a complete solution. It still shows me when updates are available,
@@ -188,70 +217,32 @@ esac
 # /usr/share/doc/unattended-upgrades# cat README.md
 # /etc/apt/apt.conf.d/50unattended-upgrades
 if isdebian; then
-    pi unattended-upgrades
-    s dd of=/etc/apt/apt.conf.d/10periodic <<'EOF'
-# this file was mostly just comments.
-APT::Periodic::Update-Package-Lists "1";
-APT::Periodic::Download-Upgradeable-Packages "1";
-APT::Periodic::AutocleanInterval "7";
-APT::Periodic::Unattended-Upgrade "1";
-EOF
-
-
-    { cat  <<'EOF'
-Unattended-Upgrade::Mail "root";
-Unattended-Upgrade::MailOnlyOnError "true";
-Unattended-Upgrade::Remove-Unused-Dependencies "true";
-Unattended-Upgrade::Origins-Pattern {
-# default is just upgrade main and security, not updates.
-EOF
-      if isdebian-testing; then
-          cat <<'EOF'
-# for testing, only do security updates.
-       "origin=Debian,codename=${distro_codename},label=Debian-Security";
-EOF
-      else
-          cat <<'EOF'
-# These are stable packages only getting bugfixes anyways.
-       "origin=*";
-EOF
-      fi
-      cat <<'EOF'
-};
-EOF
-    } | s dd of=/etc/apt/apt.conf.d/50unattended-upgrades
-
-
-    echo $- > /tmp/x
+    setup-debian-auto-update
 fi
 
-# cron
-/a/bin/crons/all
-
+# we've got a few dependencies later on, so install them now.
+pi "${simple_packages[@]}"
+simple_packages=()
 
 case $HOSTNAME in
-    lj|lk)
-
-        pi "${simple_packages[@]}"
-        $src/homepage-setup
-        $src/
-
-#         start=' *<source lang="bash"> *'
-#         end=' *<\/source> *'
-#         ruby <<'EOF' | sed -rn "/^$start$/,/^$end$/{s/^$start|$end$/# \0/;p}" | bash
-# require 'json'
-# puts JSON.parse(`curl 'https://ofswiki.org/w/api.php?\
-# action=query&titles=Mediawiki_Setup_Guide&prop=revisions&rvprop=content&\
-# format=json'`.chomp)['query']['pages'].values[0]['revisions'][0]['*']
-# EOF
-#         nginx-site iankelling.org
+    lj|li)
+
+        case $HOSTNAME in
+            lj) domain=iank.bid ;;
+            li) domain=iankelling.org ;;
+        esac
+        /a/h/setup.sh $domain
+        /a/h/build.rb
+
+        sudo -E /a/bin/mediawiki-setup/mw-setup-script
+        #$src/phab-setup
 
         echo "$0: $(date): ending now)"
         exit 0
         ;;
 esac
 
-########### end section including lj ###############
+########### end section including li/lj ###############
 
 
 case $distro in
@@ -297,7 +288,7 @@ esac
 ####### misc packages ###########
 
 
-if [[ $HOSTNAME == frodo ]]; then
+if [[ $HOSTNAME == treetowl ]]; then
     case $distro in
         debian|ubuntu)
             # note i had to do this, which is persistent:
@@ -364,6 +355,11 @@ if ! getent passwd debian-transmission > /dev/null; then
     esac
 fi
 
+# dunno why it's there, but get rid of it
+case $HOSTNAME in
+    li|lj) s rm -rf /home/linode ;;
+esac
+
 # arch had a default config,
 # debian had nothing until you start it.
 # With a little trial an error, here is a minimal config
@@ -373,7 +369,6 @@ fi
 # only settings I set were
 # hostname
 # auto-connect
-#
 for f in /home/*; do
     d=$f/.config/transmission-remote-gtk
     u=${f##*/}
@@ -383,7 +378,7 @@ for f in /home/*; do
   "profiles" : [
     {
       "profile-name" : "Default",
-      "hostname" : "frodo",
+      "hostname" : "treetowl",
       "rpc-url-path" : "/transmission/rpc",
       "username" : "",
       "password" : "",
@@ -416,7 +411,8 @@ case $distro in
         ser disable openvpn@client
         ser disable openvpn
         ;;
-    *) pi openvpn ;;
+    # suggests because we want the resolvconf package
+    *) pi --install-suggests openvpn;;
 esac
 
 pi wget
@@ -426,29 +422,31 @@ case $HOSTNAME in
             debian|ubuntu)
                 log=$(mktemp)
                 cd /a/opt
-                wget -N https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
-                set +e
-                s dpkg -i google-chrome-stable_current_amd64.deb &> $log
+                wget -nv -N https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
+                errallow
+                set -o pipefail
+                s dpkg -i google-chrome-stable_current_amd64.deb |& tee $log
                 code=$?
-                set -e
+                errcatch
                 case $code in
-                    1)
-                        if grep '^dpkg: dependency problems prevent configuration of' \
+                    0) : ;;
+                    *)
+                        # previously I had a more specific search, but dpkg
+                        # changed it's output as of 7/2016
+                        if grep 'dependency problems' \
                                 $log &>/dev/null; then
                             s apt-get -fy install
                         else
                             exit 1
                         fi
                         ;;
-                    0) : ;;
-                    *) exit $code
-                esac
-                ;;
-            arch)
-                pi google-chrome
-                ;;
-        esac
-        ;;
+esac
+;;
+arch)
+    pi google-chrome
+    ;;
+esac
+;;
 esac
 
 # printer
@@ -584,7 +582,7 @@ case $distro in
            bridge-utils dnsmasq qemu bind-tools
         # otherwise we get error about accessing kvm module.
         # seems like there might be a better way, but google was a bit vague.
-        s sed -ri '/^ *user *=/d' /etc/libvirt/qemu.conf
+        s sed -ri --follow-symlinks '/^ *user *=/d' /etc/libvirt/qemu.conf
         echo 'user = "root"' | s tee -a /etc/libvirt/qemu.conf
         # https://bbs.archlinux.org/viewtopic.php?id=206206
         # # this should prolly go in the wiki
@@ -689,6 +687,14 @@ esac
 # because no systemd user instance was running.
 # Doing systemd --user resulted in
 # Trying to run as user instance, but $XDG_RUNTIME_DIR is not set
+
+if isdebian-testing; then
+    # as of 7/2016, has no unstable deps, and is not in testing anymore.
+    pi synergy/unstable
+else
+    pi synergy
+fi
+
 case $distro in
     # ubuntu unknown. probably the same as debian, just check if the
     # init scripts come with the package.
@@ -718,9 +724,15 @@ Accept=false
 [Install]
 WantedBy=sockets.target
 EOF
+        # had this fail with 'Failed to connect to bus: No such file or directory'
+        # then when I tried it manually, it worked fine...
+        if ! systemctl --user daemon-reload; then
+            sleep 2
+            echo retrying systemd user daemon reload
+            systemctl --user daemon-reload
+        fi
         ;;&
     *)
-        pi synergy
         # taken from arch wiki.
         s dd of=/etc/systemd/system/synergyc@.service <<'EOF'
 [Unit]
@@ -729,7 +741,7 @@ After=network.target
 
 [Service]
 User=%i
-ExecStart=/usr/bin/synergyc --no-daemon treetowl
+ExecStart=/usr/bin/synergyc --no-daemon frodo
 Restart=on-failure
 # per man systemd.unit, StartLimitInterval, by default we
 # restart more than 5 times in 10 seconds.
@@ -739,14 +751,16 @@ RestartSec=3s
 [Install]
 WantedBy=multi-user.target
 EOF
+        s systemctl daemon-reload
         case $HOSTNAME in
-            frodo)
+            x2|treetowl)
                 ser enable synergyc@ian
                 ser start synergyc@ian ||: # X might not be running yet
+                ;;
+            frodo)
                 systemctl --user start synergys ||:
                 systemctl --user enable synergys
                 ;;
-            treetowl) systemctl --user enable synergys ;;
         esac
         ;;
 esac
@@ -775,7 +789,7 @@ pi smartmontools
 # -o on, turn on 4 hour period non-performance degrading testing.
 # short test daily 2-3am, extended tests Saturdays between 3-4am:
 sched="-s (S/../.././02|L/../../6/03)"
-s sed -i "s#^[[:space:]]*DEVICESCAN.*#\
+s sed -i --follow-symlinks "s#^[[:space:]]*DEVICESCAN.*#\
 DEVICESCAN -a -o on -S on -n standby,q $sched\
 -m ian@iankelling.org -M exec /usr/local/bin/smart-notify#" /etc/smartd.conf
 
@@ -785,7 +799,7 @@ DEVICESCAN -a -o on -S on -n standby,q $sched\
 # consulted first. This is often slower and undesirable, ie. local dns
 # queries go from 0ms to 10+ or 100+ ms. To reverse the ordering, you
 # can do:
-#sudo sed -i '/tun\*\|tap\*/d' /etc/resolvconf/interface-order
+#sudo sed -i --follow-symlinks '/tun\*\|tap\*/d' /etc/resolvconf/interface-order
 # however, this breaks dns lookup for hosts on the openvpn lan.
 # I can\'t figure out why hosts on the normal lan would not be
 # broken under the default ordering, except the host I was
@@ -796,6 +810,22 @@ DEVICESCAN -a -o on -S on -n standby,q $sched\
 ########### misc stuff
 
 
+s cedit /etc/goaccess.conf <<'EOF'
+# all things found from looking around the default config
+# copied existing NCSA Combined Log Format with Virtual Host, plus %L
+log-format %^:%^ %h %^[%d:%t %^] "%r" %s %b "%R" "%u" %L
+time-format %H:%M:%S
+date-format %d/%b/%Y
+log-file /var/log/apache2/access.log
+color-scheme 2
+EOF
+
+
+if [[ $HOSTNAME == treetowl ]] && ! sudo test -e /etc/openvpn/client.key; then
+    /a/bin/vpn-setup/vpn-mk-client-cert dopub
+fi
+
+
 case $distro in
     debian|ubuntu)
         case `debian-archive` in
@@ -810,12 +840,10 @@ EOF
                 # deal with mismatching unison compilers, but I dont
                 # see any reason to revert it, since it only installs
                 # a single package which is primarily a single binary
-                pi unison-gtk/testing unison/testing
-                ;;
-            testing)
-                piunison unison-gtk
                 ;;
         esac
+        pi unison/testing
+        pi unison-gtk/testing # after to make it the default unison
         ;;
     arch)
         pi unison gtk2
@@ -939,26 +967,19 @@ EOF
         ;;
 esac
 
-if [[ $HOSTNAME == frodo ]]; then
-    tu /etc/exports <<'EOF'
-/k 192.168.1.0/24(rw,nohide,no_subtree_check,insecure)
-EOF
-    s exportfs -rav
-fi
-
-if [[ -e /k/video ]]; then
+if [[ $HOSTNAME == treetowl ]]; then
     # nohide = export filesystems mounted deeper than the export point
     # fsid=0 makes this export the "root" export
     # not documented in the man page, but this means
     # 1. it can be mounted with a shorthand of server:/
     # 2. exports that are subdirectories of this one will automatically be mounted
-    tu /etc/exports '/i/video 192.168.1.0/24(rw,fsid=0,nohide,no_root_squash,async,no_subtree_check,insecure)'
+    tu /etc/exports <<'EOF'
+/k 192.168.1.0/24(rw,fsid=0,nohide,no_root_squash,async,no_subtree_check,insecure)
+EOF
     s exportfs -rav
-    showmount -e localhost
 fi
 
 
-
 e "$end_msg_var"
 
 
@@ -1023,45 +1044,49 @@ if ! s virsh list --all --name | grep -xF win10 &>/dev/null; then
 fi
 
 
-pi samba
-# note samba re-reads it's config every 1 minute
-case $distro in
-    arch) s cp /etc/samba/smb.conf.default /etc/samba/smb.conf ;;
-esac
+if [[ $HOSTNAME == treetowl ]]; then
+    pi samba
+    # note samba re-reads it\'s config every 1 minute
+    case $distro in
+        arch) s cp /etc/samba/smb.conf.default /etc/samba/smb.conf ;;
+    esac
 
-# add 2 lines after workgroup option
-s sed -ri '/^\s*encrypt passwords\s*=/d' /etc/samba/smb.conf
-s sed -ri '/^\s*map to guest\s*=/d' /etc/samba/smb.conf
-s sed -i 's/\(\s*workgroup\s*=\).*/\1 WORKGROUP\n\tencrypt passwords = yes\n\tmap to guest = bad password/'  /etc/samba/smb.conf
-# remove default homes section. not sharing that.
-s sed -ri '/^\s*\[homes\]/,/\s*\[/d' /etc/samba/smb.conf
+    # add 2 lines after workgroup option
+    s sed -ri --follow-symlinks '/^\s*encrypt passwords\s*=/d' /etc/samba/smb.conf
+    s sed -ri --follow-symlinks '/^\s*map to guest\s*=/d' /etc/samba/smb.conf
+    s sed -i --follow-symlinks 's/\(\s*workgroup\s*=\).*/\1 WORKGROUP\n\tencrypt passwords = yes\n\tmap to guest = bad password/'  /etc/samba/smb.conf
+    # remove default homes section. not sharing that.
+    s sed -ri --follow-symlinks '/^\s*\[homes\]/,/\s*\[/d' /etc/samba/smb.conf
 
-if ! grep -xF '[public]' /etc/samba/smb.conf &>/dev/null; then
-    s tee -a /etc/samba/smb.conf <<'EOF'
+    if ! grep -xF '[public]' /etc/samba/smb.conf &>/dev/null; then
+        s tee -a /etc/samba/smb.conf <<'EOF'
 [public]
       guest ok = yes
       read only = no
-      path = /kfrodo
+      path = /kr
 EOF
-fi
+    fi
 
-case $distro in
-    debian|ubuntu)
-# systemd claims it generates units from /etc/init.d, but it clearly doesn't
-# in debian. I have no idea how they are related. fuck debian right now. It's
-# not documented.  samba has a systemd init file linked to /dev/null.
-# There's this https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=769714 which
-# claims samba's sub-services will be started automatically by systemd... it
-# didn't on install, wonder if it will on boot. It clued me in how to start
-# it manually though. Nothing in /usr/share/doc/samba, debian admin guide
-# says nothing about any of this. (this is in debian testing as of 4/2016).
-
-s /etc/init.d/samba start
-;;
-                        arch)
-                            sgo samba
-                            ;;
-esac
+    case $distro in
+        debian|ubuntu)
+            # systemd claims it generates units from /etc/init.d, but it
+            # clearly doesn\'t in debian. I have no idea how they are
+            # related. fuck debian right now. It\'s not documented.  samba
+            # has a systemd init file linked to /dev/null.  There\'s this
+            # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=769714 which
+            # claims samba\'s sub-services will be started automatically by
+            # systemd... it didn\'t on install, wonder if it will on
+            # boot. It clued me in how to start it manually though. Nothing
+            # in /usr/share/doc/samba, debian admin guide says nothing about
+            # any of this. (this is in debian testing as of 4/2016).
+
+            s /etc/init.d/samba start
+            ;;
+        arch)
+            sgo samba
+            ;;
+    esac
+fi
 
 tu /etc/hosts <<< "127.0.1.1 $(hostname).lan $(hostname)"